#include <nemo/error.h>
#include <nemo/byte.h>

#include "djbio.h"
#include "getln.h"

int getln2_max(register djbio *iop, register stralloc *out, byte_t **cont, unsigned int *clen, char sep, unsigned int maxlen)
{
  register byte_t *x;
  register unsigned int i;
  register int n;

  if (!stralloc_erase(out)) return -1;

  for (;;) {
    n = djbio_feed(iop);
    if (n < 0) return -1;
    if (n == 0) {
      *clen = 0;
      return 0;
    }
    x = djbio_PEEK(iop);
    i = byte_chr(x, (unsigned int)n, sep);
    if (out->len + i > maxlen) {
      errno = error_proto;
      return -1;
    }
    if (i < (unsigned int)n) {
      *clen = i + 1;
      djbio_SEEK(iop, *clen);
      *cont = x;
      return 0;
    }
    if (!stralloc_readyplus(out, (unsigned int)n)) return -1;
    i = out->len;
    out->len = i + (unsigned int)djbio_get(iop, out->s + i, (unsigned int)n);
  }
}
