#include <nemo/error.h>
#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/unix.h>

#include "djbio.h"
#include "getln.h"
#include "readclose.h"

static inline int cleanup(int fd)
{
  close(fd);
  return -1;
}

int readlistclose_append(register int fd, register sa_vector *out)
{
  static stralloc line = STRALLOC;
  unsigned int match;
  djbio io_in;
  char buffer[128];

  match = 0;
  djbio_initread(&io_in, read, fd, buffer, sizeof(buffer));
  for (;;) {
    if (getln(&io_in, &line, &match, '\n') < 0) {
      if (errno == error_intr) continue;
      return cleanup(fd);
    }
    stralloc_trim(&line, " \t\r\n", 4);
    if (line.len && line.s[0] != '#') {
      if (!sa_vector_append(out, &line)) return cleanup(fd);
    }
    if (!match) break;
  }
  if (close(fd) < 0) return -1;
  return 1;
}

int readlistclose(register int fd, register sa_vector *out)
{
  if (!sa_vector_erase(out)) return cleanup(fd);
  return readlistclose_append(fd, out);
}
