/* sgetopt.c, sgetopt.h: (yet another) improved getopt clone, outer layer
D. J. Bernstein, djb@pobox.com.
Depends on subgetopt.h, djbio.h, subfd.h.
No system requirements.
19970208: Cleanups.
931201: Baseline.
No known patent problems.

Documentation in sgetopt.3.
*/

#include "djbio.h"
#include "djbiofd.h"
#define SGETOPTNOSHORT
#include "sgetopt.h"
#define SUBGETOPTNOSHORT

#define getopt sgetoptmine
#define optind subgetoptind
#define opterr sgetopterr
#define optproblem subgetoptproblem
#define optprogname sgetoptprogname

int opterr = 1;
char *optprogname = 0;
static char nullstr[] = "";

int getopt(int argc, char **argv, const char *opts)
{
  register int c;
  register char *s;
  char chp[2];

  if (!optprogname) {
    optprogname = *argv;
    if (!optprogname) optprogname = nullstr;
    for (s = optprogname; *s; ++s) {
      if (*s == '/') optprogname = s + 1;
    }
  }
  c = subgetopt(argc, argv, opts);
  if (opterr) {
    if (c == '?') {
      chp[0] = (char)optproblem;
      chp[1] = '\n';
      djbio_puts(djbiofd_err, optprogname);
      if (argv[optind] && (optind < argc)) {
        djbio_puts(djbiofd_err, ": illegal option -- ");
      }
      else {
        djbio_puts(djbiofd_err, ": option requires an argument -- ");
      }
      djbio_put(djbiofd_err, chp, 2);
      djbio_flush(djbiofd_err);
    }
  }
  return c;
}
