#ifndef NEMO_SOCKET_H
#define NEMO_SOCKET_H

#include <nemo/stdint.h>
#include <nemo/ip4.h>
#include <nemo/ip6.h>

#ifdef __cplusplus
extern "C" {
#endif

unsigned int	socket_connected(int s);

int	socket_listen(int s, int backlog);
int	socket_tcp_no_delay(int s);
int	socket_ip_options_kill(int s);
int	socket_oob_inline(int s);

void	socket_try_reserve_in(int s, int size);

int	socket_shutdown_recvs(int s);
int	socket_shutdown_sends(int s);
int	socket_shutdown_duplex(int s);

int	socket4_tcp(void);
int	socket4_udp(void);

int	socket4_bind(int s, const ip4_address *ip, uint16_t port);
int	socket4_bind_reuse(int s, const ip4_address *ip, uint16_t port);

int	socket4_accept(int s, ip4_address *ip, uint16_t *port);
int	socket4_connect(int s, const ip4_address *ip, uint16_t port);
int	socket4_send(int s, const void *buf, unsigned int len, const ip4_address *ip, uint16_t port);

int	socket4_local(int s, ip4_address *ip, uint16_t *port);
int	socket4_remote(int s, ip4_address *ip, uint16_t *port);
int	socket4_recv(int s, void *buf, unsigned int len, ip4_address *ip, uint16_t *port);

int	socket6_tcp(void);
int	socket6_udp(void);

int	socket6_bind(int s, const ip6_address *ip, uint16_t port);
int	socket6_bind_reuse(int s, const ip6_address *ip, uint16_t port);

int	socket6_accept(int s, ip6_address *ip, uint16_t *port);
int	socket6_connect(int s, const ip6_address *ip, uint16_t port);
int	socket6_send(int s, const void *buf, unsigned int len, const ip6_address *ip, uint16_t port);

int	socket6_local(int s, ip6_address *ip, uint16_t *port);
int	socket6_remote(int s, ip6_address *ip, uint16_t *port);
int	socket6_recv(int s, void *buf, unsigned int len, ip6_address *ip, uint16_t *port);

#ifdef __cplusplus
}
#endif

#endif
