#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <nemo/byte.h>

#include "socket.h"

#include <nemo/uint16.h>

int socket6_local(int s, ip6_address *ip, uint16_t *port)
{
  struct sockaddr_in6 sa;
  socklen_t len;

  len = sizeof(sa);
  if (getsockname(s, (struct sockaddr *)&sa, &len) < 0) return -1;
  if (ip) {
    ip6_unpack(ip, &sa.sin6_addr);
    ip->sid = sa.sin6_scope_id;
  }
  if (port) {
    uint16_unpack_big(port, &sa.sin6_port);
  }
  return 0;
}
