#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <nemo/byte.h>

#include "socket.h"

#include <nemo/uint16.h>

int socket6_recv(int s, void *buf, unsigned int len, ip6_address *ip, uint16_t *port)
{
  register ssize_t r;
  struct sockaddr_in6 sa;
  socklen_t slen;

  slen = sizeof sa;
  r = recvfrom(s, buf, len, 0, (struct sockaddr*)&sa, &slen);
  if (r < 0) return -1;
  ip6_unpack(ip, &sa.sin6_addr);
  ip->sid = sa.sin6_scope_id;
  uint16_unpack_big(port, &sa.sin6_port);
  return (int)r;
}
