#ifndef NEMO_TIMEOUTIO_H
#define NEMO_TIMEOUTIO_H

#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/ip4.h>
#include <nemo/ip6.h>

#ifdef __cplusplus
extern "C" {
#endif

int	timeoutio4_accept(int s, unsigned int timeout);
int	timeoutio4_connect(int s, const ip4_address *ip, const ip4_address *outip, uint16_t port, unsigned int timeout);

int	timeoutio6_accept(int s, unsigned int timeout);
int	timeoutio6_connect(int s, const ip6_address *ip, const ip6_address *outip, uint16_t port, unsigned int timeout);

ssize_t	timeoutio_read(unsigned int timeout, int fd, void *buf, size_t len);
ssize_t	timeoutio_write(unsigned int timeout, int fd, const void *buf, size_t len);

#ifdef __cplusplus
}
#endif

#endif
