#include <nemo/stdint.h>
#include <nemo/unixtypes.h>

#include <nemo/ndelay.h>
#include <nemo/select.h>
#include <nemo/error.h>

#include "timeoutio.h"

#include <sys/socket.h>
#include <netinet/in.h>

int timeoutio6_accept(int s, unsigned int timeout)
{
  struct sockaddr_in6 sa;
  struct timeval tv;
  fd_set rfds;
  int fd;
  unsigned int dummy;

  if (ndelay_on(s) < 0) return -1;

  FD_ZERO(&rfds);
  FD_SET((unsigned int)s, &rfds);
  tv.tv_sec = (time_t)timeout;
  tv.tv_usec = 0;

  if (select(s + 1, &rfds, (fd_set *) 0, (fd_set *) 0, &tv) < 0) return -1;

  dummy = sizeof sa;
  fd = accept(s, (struct sockaddr *) &sa, &dummy);
  if (fd < 0) return -1;

  ndelay_off(s);
  return fd;
}
