#include <nemo/error.h>

#include "iopause.h"
#include "timeoutio.h"

#include <nemo/unix.h>

ssize_t timeoutio_read(unsigned int timeout, int fd, void *buf, size_t len)
{
  struct taia now;
  struct taia deadline;
  iopause_fd x;

  taia_now(&now);
  taia_uint(&deadline, timeout);
  taia_add(&deadline, &now, &deadline);

  x.fd = fd;
  x.events = IOPAUSE_READ;
  for (;;) {
    taia_now(&now);
    iopause(&x, 1, &deadline, &now);
    if (x.revents) break;
    if (taia_less(&deadline, &now)) {
      errno = error_timeout;
      return -1;
    }
  }
  return read(fd, buf, len);
}
